#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
using namespace std;

double factorial(int x);
void vivod(double **arr, int n);

int main()
{
	setlocale(0, "russian");
	ofstream out("Output.out");
	if(!out)
	{
		cout <<"  ./n";
		system("Pause");
		return 1;
	}
	cout <<" -  ";
	cout.unsetf(ios::scientific | ios::fixed);
	int n;
	long double *parr;
	double **arr, f;
	cin >>n;
	

//--------------------------------------------------------- ----------------------------------------------------------------------	
	try{
		arr= new double *[n];
	}catch(bad_alloc xa){
		cout <<".\n";
		system("Pause");
		return 1;
	}

	for(int i= 0; i < n; i++)
	{	
		try{
			arr[i]= new double [n];
		}catch(bad_alloc xa){
			cout <<".\n";
			system("Pause");
			return 1;
		}
		for(int j= 0; j < n; j++){
			f= factorial(j);
			arr[i][j]= 1/pow(f,i);
		}
	}

//------------------------------------------------------------------  ------------------------------------------------------------------------------	
	vivod(arr, n);
	
//----------------------------------------------------------------- ------------------------------------------------------------------------------	
	try{
		parr= new long double [n];
	}catch(bad_alloc xa){
		cout <<".\n";
		system("Pause");
		return 1;
	}
	for(int i= 0; i < n; i++)
	{
		parr[i]= 0;
		for(int j= 0; j < n; j++)
		{
			parr[i]+= arr[i][j];
		}
	}

//-----------------------------------------------------------------C---------------------------------------------------------------------------
	long double obmen;
	int imin;
	for(int j= 0;j < n;j++)
	{
		imin= j;
		for(int i= j+1;i < n;i++)
		{
			if(parr[i] < parr[imin]) imin= i;
		}
		if(parr[j] != parr[imin])
		{
			obmen= parr[j];
			parr[j]= parr[imin];
			parr[imin]= obmen;
			for(int k=0;k < n;k++)
			{
				obmen= arr[j][k];
				arr[j][k]= arr[imin][k];
				arr[imin][k]= obmen;
			}
		}
	}

//------------------------------------------------------------------ -----------------------------------------------------------
	cout <<"\n\n\n \n";
	vivod(arr, n);

//--------------------------------------------------------------------The End---------------------------------------------------------------
	system("Pause");
	for(int i= 0;i < n; i++)
	{
		delete [] arr[i];
	}
	delete [] arr;
	delete [] parr;
	return 0;
}

double factorial(int x)
{
	long int f= 1; 
	for(int k= 1; k < (x+1); k++) f*= k;
	return (long double)f;
}

void vivod(double **arr, int n)
{
		int k, t= 0;
	do{
		k= t;
		t+= 9;
		cout <<setw(3) <<"  "; 
		for(int j= k; (j < t)&&(j < n); j++) cout <<setw(8) <<(j+1);
		cout <<"\n-------------------------------------------------------------------------------\n";
		for(int i= 0; i < n; i++){
			cout <<setw(3) << i+1 <<"  ";
			for(int j= k; (j < t)&&(j < n); j++){
				cout <<setprecision(1) <<setw(8) <<arr[i][j];
			}
			cout <<"\n";
		}
	cout <<"\n\n";
	}while(t < n);
}