#include <iostream>
#include <cmath>
#include <iomanip>
using namespace std;

double podshet_riada(double x, int n, double &ss_p);

int main()
{
	setlocale(0,"russian");
	cout <<setw(2) <<"x" <<setw(10) <<"S(x)" <<setw(12) <<"Y(x)" <<setw(6) <<"n\n";
	double s,y,s_p;
	int n;

	for(double x= 0; x <= 1.0; x= x+0.2)
	{
		s_p= s= 1;
		n= 0;
		do{	
			s+= podshet_riada(x, n, s_p);
			n++;
		}while(abs(s_p) > 0.000001);
		y= (1-((x*x)/2))*cos(x)-(x/2)*sin(x);
		cout <<fixed <<setprecision(1) <<setw(3) <<x <<setprecision(8) <<setw(12) <<s <<setprecision(8) <<setw(12) <<y <<setw(3) <<n <<"\n";
	}

	system("Pause");
	return 0;
}

double podshet_riada(double x, int n, double &ss_p) //        
{
	ss_p*= (x*x*(2*n*n+4*n+3))/((2*n+1)*(2*n+2)*(2*n*n+1));
	if((n%2) == 0) return -ss_p;
		else return ss_p;
}