#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
using namespace std;

double factorial(int x);

int main()
{
	setlocale(0, "russian");
	ofstream out("Output.out");
	if(!out)
	{
		cout <<"  ./n";
		system("Pause");
		return 1;
	}
	cout <<" -  ";
	cout.unsetf(ios::scientific | ios::fixed);
	int n;
	long double *parr;
	double **arr, f;
	cin >>n;
	

//--------------------------------------------------------- ----------------------------------------------------------------------	
	try{
		arr= new double *[n];
	}catch(bad_alloc xa){
		cout <<".\n";
		system("Pause");
		return 1;
	}

	for(int i= 0; i < n; i++)
	{	
		try{
			arr[i]= new double [n];
		}catch(bad_alloc xa){
			cout <<".\n";
			system("Pause");
			return 1;
		}
		for(int j= 0; j < n; j++){
			f= factorial(j);
			arr[i][j]= 1/pow(f,i);
		}
	}

//------------------------------------------------------------------  ------------------------------------------------------------------------------	
	if((n <= 12)&&(n > 7))
	{
		for(int i= 0;i < n; i++){
			for(int j= 0;j < n; j++){
				cout <<setprecision(1) <<arr[i][j] <<setw(7);
			}
			cout <<"\n";
		}
		cout <<"\n\n";
	}else{
		for(int i= 0;i < n; i++) out <<setw(11) <<i;
		cout <<"\n";
		for(int i= 0;i < n; i++){
			for(int j= 0;j < n; j++){
				cout <<setprecision(4) <<arr[i][j] <<setw(11);
			}
			cout <<"\n\n";
		}
		cout <<"\n\n";
	}
	

//----------------------------------------------------------------- ------------------------------------------------------------------------------	
	try{
		parr= new long double [n];
	}catch(bad_alloc xa){
		cout <<".\n";
		system("Pause");
		return 1;
	}
	for(int i= 0; i < n; i++)
	{
		parr[i]= 0;
		for(int j= 0; j < n; j++)
		{
			parr[i]+= arr[i][j];
		}
	}

//-----------------------------------------------------------------C---------------------------------------------------------------------------
	long double obmen;
	int imin;
	for(int j= 0;j < n;j++)
	{
		imin= j;
		for(int i= j+1;i < n;i++)
		{
			if(parr[i] < parr[imin]) imin= i;
		}
		if(parr[j] != parr[imin])
		{
			obmen= parr[j];
			parr[j]= parr[imin];
			parr[imin]= obmen;
			for(int k=0;k < n;k++)
			{
				obmen= arr[j][k];
				arr[j][k]= arr[imin][k];
				arr[imin][k]= obmen;
			}
		}
	}

//------------------------------------------------------------------ ------------------------------------------------------------------------------	
	if((n <= 12)&&(n > 7))
	{
		for(int i= 0;i < n; i++){
			for(int j= 0;j < n; j++){
				cout <<setprecision(1) <<arr[i][j] <<setw(7);
			}
			cout <<"\n";
		}
		cout <<"\n\n";
	}else{
		for(int i= 0;i < n; i++) out <<setw(11) <<i;
		cout <<"\n";
		for(int i= 0;i < n; i++){
			for(int j= 0;j < n; j++){
				cout <<setprecision(4) <<arr[i][j] <<setw(11);
			}
			cout <<"\n\n";
		}
		cout <<"\n\n";
	}

//--------------------------------------------------------------------The End-----------------------------------------------------------------------------------
	system("Pause");
	for(int i= 0;i < n; i++)
	{
		delete [] arr[i];
	}
	delete [] arr;
	delete [] parr;
	return 0;
}

double factorial(int x)
{
	long int f= 1; 
	for(int k= 1; k < (x+1); k++) f*= k;
	return (long double)f;
}