#include <iostream>
#include <iomanip>
using namespace std;

double **obrat(double **mat, int n);
void ymnog(double **mat1, double **mat2, int n);
void ymnog(double **mat1, double *mat2, int n);
void slau();

void main()
{
	int n;
    setlocale(LC_ALL,".1251");
	cout << "  .\n";
	cout << "   ";
	cin >> n;
		
		double **mat= new double *[n];
	for (int i= 0; i < n; i++)
		mat[i]= new double [n];

//---------------------------------------------------------------------- --------------------------------------------------------------------
	cout << "\n  \n";
	for (int i= 0; i < n; i++)
		for(int j= 0; j < n; j++)
			cin >> mat[i][j];

//----------------------------------------------------------------------()------------------------------------------------------------------
/*	cout << "  : \n";
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++) 
			cout << setw(8) << fixed << setprecision(3) << mat[i][j]<<"   ";
		cout <<"\n";
	}
*/
//----------------------------------------------------------------------  ------------------------------------------------------
	double **mat_ob=obrat(mat,n);
	cout <<"  : \n";
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++) 
			cout << setw(8) << fixed << setprecision(3) << mat_ob[i][j] << "   ";
		cout <<"\n";
	}

	ymnog(mat,mat_ob,n);                     // 
	
//------------------------------------------------------------------------- II---------------------------------------------------------------------
//------------------------------------------------------------------------ ------------------------------------------------------------------
	cout << "\n  .\n";
	slau();
	system("Pause");
}

double **obrat(double **mat, int n)
{
	double a,b,c;
	double *mas= new double[2*n];

	//   
	double **mat_ed= new double *[n];
	for(int i= 0; i < n;i++)
		mat_ed[i]= new double [n];
	for(int i= 0; i < n; i++)
		for(int j= 0; j < n; j++)
		{
			if(i == j) mat_ed[i][j]= 1;
			else mat_ed[i][j]= 0;
		}

	//   
	double **mat_help= new double *[n];
	for(int i= 0; i < n; i++)
		mat_help[i]= new double [2*n];

	for(int i= 0; i < n; i++)
		for(int j= 0; j < (2*n); j++)
		{
			if(j < n)
				mat_help[i][j]= mat[i][j];
			else mat_help[i][j]= mat_ed[i][j-n];
		}

	//  
	for(int k= 0; k < n; k++)                          //      
	{
		if (mat_help[k][k] == 0)
		{
			for(int i= k+1; i < n; i++)
			{
				if(mat_help[i][k] != 0)
				{
					for(int j= 0; j < n*2; j++)
					{
						c= mat_help[i][j];
						mat_help[i][j]= mat_help[k][j];
						mat_help[k][j]= c;
					}
					break;
				}
			}
		}
		for(int i= k; i < n; i++)                      //  (k-)   = 1    ()= 0
		{
			if(i == k)                                 // (k-)          
			{
				for(int j= 0; j < 2*n; j++)
					mas[j]= mat_help[i][j];
			}

			for(int j= k; j < 2*n; j++)                //    
			{
				if(i == k)
				{
					if(j == k) a= mat_help[k][k];      //    i- 
					mat_help[i][j]= mat_help[i][j]/a;  //  j-  i-          
				}else{
					if(j == k) b= mat_help[i][j];      
					mat_help[i][j]= mat_help[i][j]-mas[j]*b/a;  //    
				}
			}
		}
	}
	//  ( ,     )
	for (int k= n-1; k >= 0; k--)
		for(int i= k; i >= 0; i--)
		{
			if(i == k)
			{
				for(int j= 0; j < 2*n; j++)
					mas[j]= mat_help[i][j];
			}

			for(int j= k; j < 2*n; j++)
			{
				if(i == k)
				{
					if(j == k) a= mat_help[k][k];
					mat_help[i][j]= mat_help[i][j]/a;
				}else{
					if(j == k) b= mat_help[i][j];
					mat_help[i][j]= mat_help[i][j]-mas[j]*b/a;
				}
			}
		}

	double **mat_ob= new double*[n];
	for (int i= 0; i < n; i++)
		mat_ob[i]=new double [n];
	for (int i= 0; i < n; i++)
		for(int j= 0; j < n; j++)
			mat_ob[i][j]= mat_help[i][j+n];

	return mat_ob;
}

void ymnog(double **mat1, double **mat2, int n)
{
	double s;
	double **mat= new double *[n];
	for(int i= 0; i < n; i++) 
		mat[i]= new double [n];
	for(int i= 0; i < n; i++)
	{
		for(int j= 0; j < n; j++)0
		{
			s= 0;
			for(int k= 0; k < n; k++)
				s= s+mat1[i][k]*mat2[k][j];
			if(i == j)mat[i][j]= 1;else                //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			 mat[i][j]= s;
			
		}
		
	}

	cout <<"    : \n";
	for (int i=0; i < n; i++)
	{
		for (int j=0; j < n; j++) 
			cout << setw(8) << fixed << setprecision(3) << abs(mat[i][j]) << "   ";
		cout <<"\n";
	}
}

void ymnog(double **mat1, double *mat2, int n)
{
	double s;
	double *mat= new double[n];
	for (int i= 0; i < n; i++)
	{
		s= 0;
		for (int j= 0; j < n; j++)
		{
			s= s+mat1[i][j]*mat2[j];
		}
		mat[i]= s;
	}

	cout << "\n:\n";
	for (int i= 0; i < n; i++) 
		cout << "x" << i+1 << " = " << mat[i] << "\n";
}


void slau()
{
	int n,i,j;
	cout <<"     - ";
	cin >>n;
	double **mat= new double *[n];
	for (int i=0; i<n;i++)
		mat[i]= new double [n];

	for (int i=0; i < n; i++)
	{
		cout <<"  : "  <<i+1 <<"\n";
		for(int j=0; j < n; j++)
			cin >> mat[i][j];
	}
	double **mat_ob= obrat(mat,n);
	double *svob= new double [n];
	cout <<"   :\n";
	for(int j= 0; j < n; j++)
		cin >>svob[j];
	ymnog(mat_ob,svob,n);
}